; LoadImageFromFile version 1.0 by Vortex

; References :

; Rendering GIF, JPEG, Icon, or Bitmap Files with OleLoadPicture
; http://www.codeproject.com/KB/graphics/render.aspx?display=PrintAll&fid=1289&df=90&mpp=25&noise=3&sort=Position&view=Quick&fr=26&select=96430

; Going from a JPG/GIF/BMP File to a HBITMAP File Using Plain API
; http://www.codeguru.com/cpp/g-m/bitmap/article.php/c4935

.386
.model flat,stdcall
option casemap:none

include LoadImage.inc

.data

IID_IPicture GUID <7BF80980h,0BF32h,101Ah,<8Bh,0BBh,00h,0AAh,00h,30h,0Ch,0ABh>>

.code

LoadImageFromFile PROC pImageFileName:DWORD

LOCAL hHeap:DWORD
LOCAL pMem:DWORD
LOCAL hOLEimg:DWORD
LOCAL hBitmap:DWORD
LOCAL pPicture:DWORD

    mov     hBitmap,0
    mov     pPicture,0
    
    invoke  GetProcessHeap
    test    eax,eax
    jz      _exit
    
    mov     hHeap,eax
    invoke  HeapAlloc,eax,HEAP_ZERO_MEMORY,2*MAX_PATH
    test    eax,eax
    jz      _exit
    
    mov     pMem,eax
    invoke  MultiByteToWideChar,CP_ACP,NULL,pImageFileName,-1,eax,2*MAX_PATH
    test    eax,eax
    jz      FreeMem
    
    invoke  OleLoadPicturePath,pMem,0,0,0,ADDR IID_IPicture,ADDR pPicture
    test    eax,eax
    jnz     FreeMem

    lea     eax,hOLEimg
    push    eax
    mov     eax,pPicture
    push    eax
    mov     eax,DWORD PTR [eax]
    call    IPicture.get_Handle[eax]
    test    eax,eax
    jnz     ReleasePict

    invoke  CopyImage,hOLEimg,IMAGE_BITMAP,0,0,LR_COPYRETURNORG
    test    eax,eax
    jz      ReleasePict
    mov     hBitmap,eax

ReleasePict:

    mov     eax,pPicture
    push    eax
    mov     eax,DWORD PTR [eax]
    call    IPicture.Release[eax]

FreeMem:

    invoke  HeapFree,hHeap,0,pMem
    
_exit:

    mov     eax,hBitmap
    ret

LoadImageFromFile ENDP

END

